#define _DEFAULT_SOURCE

#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include "parser.h"
#include "error.h"
#include "color.h"
#include "constante.h"

int printDir(struct dirent** contentsDir, char* path, int nbFile,
                    boolean hiddenFile){

    struct stat info;
    char permission[10] = "---------";
    int j = 0;

    //enleve les fichiers caches
    while(j < nbFile && !hiddenFile && *contentsDir[j]->d_name == '.') j++;

    //Affiche les fichiers
    while(j < nbFile){
        if(stat(contentsDir[j]->d_name, &info) == ERR){
            addperror("Erreur stat");
            return -1;
        }
        /*switch(info.st_mode){
            case S_IRUSR:
                permission[1] = 'r';
            case S_IWUSR:
                permission[2] = 'w';
            case S_IXUSR:
                permission[3] = 'x';
            case S_IRGRP:
                permission[4] = 'r';
            case S_IWGRP:
                permission[5] = 'w';
            case S_IXGRP:
                permission[6] = 'x';
            case S_IROTH:
                permission[7] = 'r';
            case S_IWOTH:
                permission[8] = 'w';
            case S_IXOTH:
                permission[9] = 'x';
        }*/
        printf("%s  %d  %ld  %s\n", permission, info.st_mode, info.st_size, contentsDir[j]->d_name);
        j++;
    }
    printf("\n");
    return 1;
}

void ls(int argc, char* argv[]){
    struct dirent** contentsDir;
    struct stat info;
    int i = 1, displayed = 0, nbFile, opt;
    boolean hiddenFile = false;
    boolean checksubDir = false;

    //Gestion des options
    while((opt = getopt(argc, argv, "aR")) != ERR){
        switch(opt){
            case 'a' : 
                hiddenFile = true;
                break;
            case 'R' : 
                checksubDir = true;
                break;
            default:
                addperror("getotp error");
        }
    }

    //Time to display
    for(i = 1; i < argc; i++){
        if(argv[i][0] != '-'){
            if(stat(argv[i], &info) == ERR){
                addperror("Erreur stat");
                return;
            }
            if(S_ISDIR(info.st_mode)){
                nbFile = scandir(argv[i], &contentsDir, 0, alphasort);
                if (nbFile < 0) {
                    addperror("Erreur scandir()");
                    return;
                }
                printf("%s : \n\n", argv[i]);
                displayed = printDir(contentsDir, argv[i], nbFile, hiddenFile);
            }
            else{
                printf("%d  %ld  %s\n", info.st_mode, info.st_size, argv[i]);
                displayed = 1;
            }
        }
    }

    if(!displayed){
        nbFile = scandir(".", &contentsDir, 0, alphasort);
        if (nbFile < 0) {
            addperror("Erreur scandir()");
            return;
        }
        displayed = printDir(contentsDir, ".", nbFile, hiddenFile);
    }

    printf("%d   %d\n", hiddenFile, checksubDir);

    return;
}


int main(int argc, char* argv[]){
    ls(argc, argv);
    printf(RESET);
}